# VERSION 13  MWB 23/02/2007 Added -nosleep switch to disable wait after obliterate
# VERSION 12  KF  23/02/2007 Tidy. Added -d command to force obliteration of duplicates.
# VERSION 11  MWB 23/02/2007 Added in Kevin's PrintTimeRemaining function

import os
import sys
import time

VaultPath = ""                                    # Needs "/" as trailing character if path is supplied.
VaultExe = "VaultImage.exe"                       # The command to execute vault... shouldn't need changing.
VaultServer = "ncltw-app0002"                     # Server to connect to.
VaultRepository = "RD Vault"                      # Repository to work in.
VaultLoginName = "Marcus.Bainbridge"              # Needs to be user to obliterate.
VaultLoginPassword = ""                           # Whatever the user's password is.
VaultObliterateCommand = "OBLITERATE -yesiamsure" # Command to perform obliteration.
VaultListDeletedCommand = "LISTDELETED"


VaultObliterateFullCommand = "%s%s %s -host \"%s\" -user \"%s\" -password \"%s\" -repository \"%s\" " % \
                              (VaultPath,
                              VaultExe,
                              VaultObliterateCommand,
                              VaultServer,
                              VaultLoginName,
                              VaultLoginPassword,
                              VaultRepository)
                              
VaultListDeletedFullCommand = "%s%s %s -host \"%s\" -user \"%s\" -password \"%s\" -repository \"%s\" " % \
                              (VaultPath,
                              VaultExe,
                              VaultListDeletedCommand,
                              VaultServer,
                              VaultLoginName,
                              VaultLoginPassword,
                              VaultRepository)
                              
AttemptDuplicates = False
NoSleep = False
VaultObliterateList = []
VaultCantObliterateList = []
TotalTime = 0

#*******************************************************************************
# Function : Main()
#*******************************************************************************
def main():
  global AttemptDuplicates
  global VaultCantObliterateList
  global VaultObliterateList
  
  CheckCommandLineArguments()
  GenerateListOfFilesToObliterate()
  VaultObliterateLogFile = open("LOG.txt", "w")
  
  if AttemptDuplicates:
    VaultObliterateList += VaultCantObliterateList
    VaultCantObliterateList = []
  
  ObliterateList(VaultObliterateLogFile)
  WriteFilesNotAttemptedToLog(VaultObliterateLogFile)
  VaultObliterateLogFile.close()
  PrintVaultLogFile()

#*******************************************************************************
# Function : ObliterateList()
#*******************************************************************************
def ObliterateList(VaultObliterateLogFile):
  global VaultObliterateList
  
  NumberOfFilesToObliterate = len(VaultObliterateList)
  NumberOfFilesObliterated = 0

  for CurrentObliterate in VaultObliterateList:
    (CurrentObliterateFilePath, CurrentObliterateObjID, CurrentObliterateDeleteID) = CurrentObliterate
    NumberOfFilesObliterated += 1
    print "Time :", time.strftime("%H:%M:%S", time.localtime())
    TimeStart = time.localtime()
    print "Attempting to obliterate file %d of %d." % (NumberOfFilesObliterated, NumberOfFilesToObliterate)
    print "%s \"%s\" %s %s" % (VaultObliterateFullCommand, CurrentObliterateFilePath, CurrentObliterateObjID, CurrentObliterateDeleteID)
    os.system("%s \"%s\" %s %s" % (VaultObliterateFullCommand, CurrentObliterateFilePath, CurrentObliterateObjID, CurrentObliterateDeleteID))
    print "Done!"
    SleepIfNeeded()
    TimeEnd = time.localtime()
    PrintTimeRemaining(TimeStart, TimeEnd, NumberOfFilesObliterated, NumberOfFilesToObliterate)
    VaultOutput = open("VaultOutput.txt", "r")
    Report = VaultOutput.read()

    if "<result success=\"no\"" in Report:
      VaultObliterateLogFile.write(Report + "\n----------\n")

    print Report
    VaultOutput.close()

#*******************************************************************************
# Function : GenerateListOfFilesToObliterate()
#*******************************************************************************
def GenerateListOfFilesToObliterate():
  global VaultCantObliterateList
  global VaultObliterateList

  VaultDeletedFiles = open("VaultOutput.txt", "r")

  for CurrentLine in VaultDeletedFiles:
    FileAlreadyInObliterateList = False
    FileAlreadyInCantObliterateList = False

    if "<deleted path=" in CurrentLine:
      CurrentFile = CurrentLine.split("\"")[1]
      ObjectID = CurrentLine.split("\"")[3]
      DeleteID = CurrentLine.split("\"")[5]

      for CurrentCheckFile in VaultCantObliterateList:
        (CurrentCheckFilePath, CurrentCheckFileID, CurrentCheckFileDeleteID) = CurrentCheckFile
        if CurrentFile == CurrentCheckFilePath:
          FileAlreadyInCantObliterateList = True
          break

      if FileAlreadyInCantObliterateList == False:
        for CurrentCheckFile in VaultObliterateList:
          (CurrentCheckFilePath, CurrentCheckFileID, CurrentCheckFileDeleteID) = CurrentCheckFile

          if CurrentFile == CurrentCheckFilePath:
            FileAlreadyInObliterateList = True
            break

        if FileAlreadyInObliterateList == True:
          VaultCantObliterateList.append((CurrentFile, ObjectID, DeleteID))
          VaultCantObliterateList.append(VaultObliterateList.pop(VaultObliterateList.index(CurrentCheckFile)))
        else:
          VaultObliterateList.append((CurrentFile, ObjectID, DeleteID))

  VaultDeletedFiles.close()

#*******************************************************************************
# Functions : SleepIfNeeded()
#*******************************************************************************
def SleepIfNeeded():
  global NoSleep

  if NoSleep == False:
    time.sleep(1.5)

#*******************************************************************************
# Functions : CheckCommandLineArguments()
#*******************************************************************************
def CheckCommandLineArguments():
  global VaultListDeletedFullCommand
  global AttemptDuplicates
  global NoSleep
  
  if len(sys.argv) > 1:
    CurrentArgumentNumber = 0
    for CurrentArgument in sys.argv:
      if "-getlist" in CurrentArgument.lower():
        os.system(VaultListDeletedFullCommand + " \"" + sys.argv[CurrentArgumentNumber + 1] +"\"")
      if "-d" in CurrentArgument.lower():
        AttemptDuplicates = True
      if "-nosleep" in CurrentArgument.lower():
        NoSleep = True

      CurrentArgumentNumber += 1

#*******************************************************************************
# Function : WriteFilesNotAttemptedToLog()
#*******************************************************************************
def WriteFilesNotAttemptedToLog(VaultObliterateLogFile):
  global VaultCantObliterateList

  if VaultCantObliterateList != []:
    VaultObliterateLogFile.write("\n\n----------\nDIDN'T ATTEMP TO DELETE THESE FILES DUE TO DUPLICATES:\n")
    for CurrentCant in VaultCantObliterateList:
      (FilePath, ObjID, DeleteID) = CurrentCant
      VaultObliterateLogFile.write(FilePath + "\n")

#*******************************************************************************
# Function : PrintVaultLogFile()
#*******************************************************************************
def PrintVaultLogFile():
  LogFile = open("LOG.txt", "r")
  print "Contents of log file:"
  print LogFile.read()
  LogFile.close()

#*******************************************************************************
# Function : PrintTimeRemaining()
#*******************************************************************************
def PrintTimeRemaining(TimeStart, TimeEnd, NumberOfFilesObliterated, NumberOfFilesToObliterate):
  global TotalTime
  
  TimeDifference = time.mktime(TimeEnd) - time.mktime(TimeStart)
  TotalTime += TimeDifference
  print "Time for last transaction = %d seconds" % int(TimeDifference)
  TimeRemaining = (TotalTime / NumberOfFilesObliterated) * (NumberOfFilesToObliterate - NumberOfFilesObliterated)
  Minutes = int(TimeRemaining/60)
  Hours   = int(Minutes/60)
  Minutes = int((Minutes - (Hours*60)))
  Seconds = int((TimeRemaining - (Minutes*60) - (Hours*60*60)))
  print "Time remaining: %2.2d:%2.2d:%2.2d" % (Hours, Minutes, Seconds)

main()
